"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const read_importer_manifest_1 = require("@pnpm/read-importer-manifest");
const path = require("path");
const rimraf = require("rimraf-then");
const writeJsonFile = require("write-json-file");
const runNpm_1 = require("./runNpm");
async function default_1(args, opts, command) {
    if (args.length && args[0].endsWith('.tgz')) {
        await runNpm_1.default(['publish', ...args]);
        return;
    }
    const prefix = args.length && args[0] || process.cwd();
    let _status;
    await fakeRegularManifest(prefix, async () => {
        const { status } = await runNpm_1.default(['publish', ...opts.argv.original.slice(1)]);
        _status = status;
    });
    if (_status !== 0) {
        process.exit(_status);
    }
}
exports.default = default_1;
async function pack(args, opts, command) {
    let _status;
    await fakeRegularManifest(opts.prefix, async () => {
        const { status } = await runNpm_1.default(['pack', ...opts.argv.original.slice(1)]);
        _status = status;
    });
    if (_status !== 0) {
        process.exit(_status);
    }
}
exports.pack = pack;
async function fakeRegularManifest(prefix, fn) {
    const { fileName, manifest, writeImporterManifest } = await read_importer_manifest_1.default(prefix);
    const exoticManifestFormat = fileName !== 'package.json';
    if (exoticManifestFormat) {
        await rimraf(path.join(prefix, fileName));
        await writeJsonFile(path.join(prefix, 'package.json'), manifest);
    }
    await fn();
    if (exoticManifestFormat) {
        await rimraf(path.join(prefix, 'package.json'));
        await writeImporterManifest(manifest, true);
    }
}
//# sourceMappingURL=publish.js.map